/* WiiDevControler */

#import <Cocoa/Cocoa.h>
#import <IOBluetooth/objc/IOBluetoothDevice.h>
#import <IOBluetooth/objc/IOBluetoothDeviceInquiry.h> 
#import <IOBluetooth/objc/IOBluetoothL2CAPChannel.h>

#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <netinet/in.h>
#include <netdb.h>

@interface WiiRemote : NSObject
{
	@public
	int sock, stream;
	struct sockaddr_un addr;
//	struct sockaddr_in addr;
	
	NSLock *streamLock, *deviceLock;
	
	int index;
	NSString *displayName;
	
	IOBluetoothDevice *device;
	IOBluetoothL2CAPChannel *ichan;
	IOBluetoothL2CAPChannel *cchan;
	IOBluetoothUserNotification *disconNote;
	IOBluetoothUserNotification *ichanNote;
	IOBluetoothUserNotification *cchanNote;
}
- (void)reinit;
@end

@interface WiiDevControler : NSObject
{
	struct WiiRemote **wiiRemotes;
	int numWiiRemotes;
	struct WiiRemote *connecting;
	
	IOBluetoothDeviceInquiry* inquiry;
	
	char basenameDisplay[128];
	char basename[104];
	
	int idleState;
	
	IBOutlet NSButton *disconnectButton;
    IBOutlet NSButton *syncButton;
    IBOutlet NSProgressIndicator *syncIndicator;
    IBOutlet NSTableView *wiiList;
    IBOutlet NSTextField *statusLine;
}
- (IBAction)disconect:(id)sender;
- (IBAction)sync:(id)sender;
@end
